package cn.iocoder.yudao.module.mes.service.task;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.mes.controller.admin.task.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.task.TaskDO;
import cn.iocoder.yudao.module.mes.dal.mysql.task.TaskMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link TaskServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(TaskServiceImpl.class)
public class TaskServiceImplTest extends BaseDbUnitTest {

    @Resource
    private TaskServiceImpl taskService;

    @Resource
    private TaskMapper taskMapper;

    @Test
    public void testCreateTask_success() {
        // 准备参数
        TaskSaveReqVO createReqVO = randomPojo(TaskSaveReqVO.class).setId(null);

        // 调用
        Long taskId = taskService.createTask(createReqVO);
        // 断言
        assertNotNull(taskId);
        // 校验记录的属性是否正确
        TaskDO task = taskMapper.selectById(taskId);
        assertPojoEquals(createReqVO, task, "id");
    }

    @Test
    public void testUpdateTask_success() {
        // mock 数据
        TaskDO dbTask = randomPojo(TaskDO.class);
        taskMapper.insert(dbTask);// @Sql: 先插入出一条存在的数据
        // 准备参数
        TaskSaveReqVO updateReqVO = randomPojo(TaskSaveReqVO.class, o -> {
            o.setId(dbTask.getId()); // 设置更新的 ID
        });

        // 调用
        taskService.updateTask(updateReqVO);
        // 校验是否更新正确
        TaskDO task = taskMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, task);
    }

    @Test
    public void testUpdateTask_notExists() {
        // 准备参数
        TaskSaveReqVO updateReqVO = randomPojo(TaskSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> taskService.updateTask(updateReqVO), TASK_NOT_EXISTS);
    }

    @Test
    public void testDeleteTask_success() {
        // mock 数据
        TaskDO dbTask = randomPojo(TaskDO.class);
        taskMapper.insert(dbTask);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbTask.getId();

        // 调用
        taskService.deleteTask(id);
       // 校验数据不存在了
       assertNull(taskMapper.selectById(id));
    }

    @Test
    public void testDeleteTask_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> taskService.deleteTask(id), TASK_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetTaskPage() {
       // mock 数据
       TaskDO dbTask = randomPojo(TaskDO.class, o -> { // 等会查询到
           o.setCode(null);
           o.setOrderDate(null);
           o.setDeliveryDate(null);
           o.setStatus(null);
           o.setProcessInstanceId(null);
           o.setRemark(null);
           o.setCreateTime(null);
       });
       taskMapper.insert(dbTask);
       // 测试 code 不匹配
       taskMapper.insert(cloneIgnoreId(dbTask, o -> o.setCode(null)));
       // 测试 orderDate 不匹配
       taskMapper.insert(cloneIgnoreId(dbTask, o -> o.setOrderDate(null)));
       // 测试 deliveryDate 不匹配
       taskMapper.insert(cloneIgnoreId(dbTask, o -> o.setDeliveryDate(null)));
       // 测试 status 不匹配
       taskMapper.insert(cloneIgnoreId(dbTask, o -> o.setStatus(null)));
       // 测试 processInstanceId 不匹配
       taskMapper.insert(cloneIgnoreId(dbTask, o -> o.setProcessInstanceId(null)));
       // 测试 remark 不匹配
       taskMapper.insert(cloneIgnoreId(dbTask, o -> o.setRemark(null)));
       // 测试 createTime 不匹配
       taskMapper.insert(cloneIgnoreId(dbTask, o -> o.setCreateTime(null)));
       // 准备参数
       TaskPageReqVO reqVO = new TaskPageReqVO();
       reqVO.setCode(null);

       reqVO.setStatus(null);
       reqVO.setProcessInstanceId(null);
       reqVO.setRemark(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<TaskDO> pageResult = taskService.getTaskPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbTask, pageResult.getList().get(0));
    }

}